﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.Package;
using Babel.Parser;
using Microsoft.VisualStudio.TextManager.Interop;

namespace Babel
{
    public static partial class Configuration
    {
        public const string Name = "Simple LS";
        public const string Extension = ".sls";

        static CommentInfo myCInfo;
        public static CommentInfo MyCommentInfo { get { return myCInfo; } }

        static Configuration()
        {
            myCInfo.BlockEnd = "*/";
            myCInfo.BlockStart = "/*";
            myCInfo.LineStart = "??";
            myCInfo.UseLineComments = false;

            // default colors - currently, these need to be declared
            TokenColor Number = CreateColor("SLS-Number", COLORINDEX.CI_BLUE, COLORINDEX.CI_USERTEXT_BK);
            TokenColor Capletter = CreateColor("SLS-CAPletter", COLORINDEX.CI_RED, COLORINDEX.CI_USERTEXT_BK);
            TokenColor Lowletter = CreateColor("SLS-Lowletter", COLORINDEX.CI_PURPLE, COLORINDEX.CI_USERTEXT_BK);

            //
            // map tokens to color classes
            //
            ColorToken((int)Tokens.NUMBER, TokenType.Keyword, Number, TokenTriggers.None);
            ColorToken((int)Tokens.CAPLETTER, TokenType.Keyword, Capletter, TokenTriggers.None);
            ColorToken((int)Tokens.LOWLETTER, TokenType.Keyword, Lowletter, TokenTriggers.None);
        }
    }
}
