﻿// VsPkg.cs : Implementation of SimpleLSHost
//

using System;
using System.Diagnostics;
using System.Globalization;
using System.Runtime.InteropServices;
using System.ComponentModel.Design;
using Microsoft.Win32;
using Microsoft.VisualStudio.Shell.Interop;
using Microsoft.VisualStudio.OLE.Interop;
using Microsoft.VisualStudio.Shell;

namespace Company.SimpleLSHost
{
    /// <summary>
    /// This is the class that implements the package exposed by this assembly.
    ///
    /// The minimum requirement for a class to be considered a valid package for Visual Studio
    /// is to implement the IVsPackage interface and register itself with the shell.
    /// This package uses the helper classes defined inside the Managed Package Framework (MPF)
    /// to do it: it derives from the Package class that provides the implementation of the 
    /// IVsPackage interface and uses the registration attributes defined in the framework to 
    /// register itself and its components with the shell.
    /// </summary>
    // This attribute tells the registration utility (regpkg.exe) that this class needs
    // to be registered as package.
    [PackageRegistration(UseManagedResourcesOnly = true)]
    // A Visual Studio component can be registered under different regitry roots; for instance
    // when you debug your package you want to register it in the experimental hive. This
    // attribute specifies the registry root to use if no one is provided to regpkg.exe with
    // the /root switch.
    [DefaultRegistryRoot("Software\\Microsoft\\VisualStudio\\9.0")]
    // This attribute is used to register the informations needed to show the this package
    // in the Help/About dialog of Visual Studio.
    [InstalledProductRegistration(false, "#110", "#112", "1.0", IconResourceID = 400)]
    // In order be loaded inside Visual Studio in a machine that has not the VS SDK installed, 
    // package needs to have a valid load key (it can be requested at 
    // http://msdn.microsoft.com/vstudio/extend/). This attributes tells the shell that this 
    // package has a load key embedded in its resources.
    [ProvideLoadKey("Standard", "1.0", "Package Name", "Company", 1)]
    [ProvideService(typeof(Company.SimpleLSHost.UserSupplied.LanguageService))]
    [ProvideLanguageExtension(typeof(Company.SimpleLSHost.UserSupplied.LanguageService), Babel.Configuration.Extension)]
    [ProvideLanguageService(typeof(Company.SimpleLSHost.UserSupplied.LanguageService), Babel.Configuration.Name, 0,
     CodeSense = true,
     EnableCommenting = true,
     MatchBraces = true,
     ShowCompletion = true,
     ShowMatchingBrace = true,
     AutoOutlining = true,
     EnableAsyncCompletion = true,
     CodeSenseDelay = 0)]
    [Guid(GuidList.guidSimpleLSHostPkgString)]
    public sealed class SimpleLSHostPackage : Babel.BabelPackage
    {

    }
}